/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataHcpVaultSecretsAppConfig extends cdktf.TerraformMetaArguments {
    /**
    * The name of the Vault Secrets application.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/hcp/0.61.0/docs/data-sources/vault_secrets_app#app_name DataHcpVaultSecretsApp#app_name}
    */
    readonly appName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/hcp/0.61.0/docs/data-sources/vault_secrets_app#id DataHcpVaultSecretsApp#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/hcp/0.61.0/docs/data-sources/vault_secrets_app hcp_vault_secrets_app}
*/
export declare class DataHcpVaultSecretsApp extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "hcp_vault_secrets_app";
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/hcp/0.61.0/docs/data-sources/vault_secrets_app hcp_vault_secrets_app} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataHcpVaultSecretsAppConfig
    */
    constructor(scope: Construct, id: string, config: DataHcpVaultSecretsAppConfig);
    private _appName?;
    get appName(): string;
    set appName(value: string);
    get appNameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get organizationId(): string;
    get projectId(): string;
    private _secrets;
    get secrets(): cdktf.StringMap;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
